<?php
namespace Modules\Parametro\Controllers; 

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\Controller;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Response\Message;

class Gop22000PercentualdeCorrecaoController extends \Teknisa\GER\Controllers\TeknisaCrud{
    protected $dataSourceManager;
    protected $connection;
    protected $newCode;
    protected $environment;

    
    public function __construct($crudService, ParameterBag $parameterBag, $dataSourceManager, $connection, $newCode, $environment) {
        $this->dataSourceManager    = $dataSourceManager;
        $this->connection = $connection;
        $this->newCode = $newCode;
        $this->environment = $environment;
        parent::__construct($crudService, $parameterBag);
    }
    
    public function saveFilial(DTO\Request $request, DTO\Response $response ){
        
       $dados = $request->getDataSet();
       
       if(!empty($dados)){
           
           $rows = $dados->getRows();
           
           if(!empty($rows)){ 
               
               foreach($rows as $row){
                   
                        $parametros =  array(
                            'P_NRPERCCORRECAOGOP' => $this->newCode->getCodeByTableName("PERCCORRECAOGOP", $this->environment->getNrorg()),
                            'P_CDFILIAL'          => $row['CDFILIAL'],
                            'P_CDANO'             => $row['CDANO'],
                            'P_NRORG'             => $this->environment->getNrorg(),
                            'P_VRMES01'           => floatval (str_replace(",", ".",$row['VRMES01'])),
                            'P_VRMES02'           => floatval (str_replace(",", ".",$row['VRMES02'])),
                            'P_VRMES03'           => floatval (str_replace(",", ".",$row['VRMES03'])),
                            'P_VRMES04'           => floatval (str_replace(",", ".",$row['VRMES04'])),
                            'P_VRMES05'           => floatval (str_replace(",", ".",$row['VRMES05'])),
                            'P_VRMES06'           => floatval (str_replace(",", ".",$row['VRMES06'])),
                            'P_VRMES07'           => floatval (str_replace(",", ".",$row['VRMES07'])),
                            'P_VRMES08'           => floatval (str_replace(",", ".",$row['VRMES08'])),
                            'P_VRMES09'           => floatval (str_replace(",", ".",$row['VRMES09'])),
                            'P_VRMES10'           => floatval (str_replace(",", ".",$row['VRMES10'])),
                            'P_VRMES11'           => floatval (str_replace(",", ".",$row['VRMES11'])),
                            'P_VRMES12'           => floatval (str_replace(",", ".",$row['VRMES12'])),
                            'P_IDTIPOORCAOP'      => $row['IDTIPOORCAOP'],
                            'P_DTINCLUSAO'        => $this->crudService->getEnvironment()->getCurrentTime()->format("d/m/Y H:i:s"),
                            'P_CDOPERINCLUSAO'    => $this->environment->getCdOperador(),
                            'P_NRORGINCLUSAO'     => $this->environment->getNrorg()
                        );
                        $stmt = $this->connection->prepare("
                             INSERT INTO
                                PERCCORRECAOGOP 
                                (
                                    NRPERCCORRECAOGOP,
                                    CDFILIAL,
                                    CDANO,
                                    NRORG,
                                    IDTIPOORCAOP,
                                    VRMES01,
                                    VRMES02,
                                    VRMES03,
                                    VRMES04,
                                    VRMES05,
                                    VRMES06,
                                    VRMES07,
                                    VRMES08,
                                    VRMES09,
                                    VRMES10,
                                    VRMES11,
                                    VRMES12,
                                    DTINCLUSAO,
                                    CDOPERINCLUSAO,
                                    NRORGINCLUSAO
                                    
                                 ) 
                            VALUES(
                                :P_NRPERCCORRECAOGOP,
                                :P_CDFILIAL,
                                :P_CDANO,
                                :P_NRORG,
                                :P_IDTIPOORCAOP,
                                :P_VRMES01,
                                :P_VRMES02,
                                :P_VRMES03,
                                :P_VRMES04,
                                :P_VRMES05,
                                :P_VRMES06,
                                :P_VRMES07,
                                :P_VRMES08,
                                :P_VRMES09,
                                :P_VRMES10,
                                :P_VRMES11,
                                :P_VRMES12,
                                :P_DTINCLUSAO,
                                :P_CDOPERINCLUSAO,
                                :P_NRORGINCLUSAO
                            )"); 
                        try{
                            $stmt->execute($parametros);
                        }catch(\Exception $ex){
                            $response->setError(new Error("Nao foi possivel processar os dados enviados   --- " . $ex->getMessage(), 500));
                        }
               }
            } 
        }
    }
    
    public function updateFilial(DTO\Request $request, DTO\Response $response ){
        
        $dados = $request->getDataSet();
        
        if(!empty($dados)){
            
            $rows = $dados->getRows();
                
            if(!empty($rows)){
               
                foreach($rows as $row){
                    
                    $parametros =  array(
                        
                        'NRPERCCORRECAOGOP' => $row["NRPERCCORRECAOGOP"],
                        'P_VRMES01'         => floatval (str_replace(",", ".",$row['VRMES01'])),
                        'P_VRMES02'         => floatval (str_replace(",", ".",$row['VRMES02'])),
                        'P_VRMES03'         => floatval (str_replace(",", ".",$row['VRMES03'])),
                        'P_VRMES04'         => floatval (str_replace(",", ".",$row['VRMES04'])),
                        'P_VRMES05'         => floatval (str_replace(",", ".",$row['VRMES05'])),
                        'P_VRMES06'         => floatval (str_replace(",", ".",$row['VRMES06'])),
                        'P_VRMES07'         => floatval (str_replace(",", ".",$row['VRMES07'])),
                        'P_VRMES08'         => floatval (str_replace(",", ".",$row['VRMES08'])),
                        'P_VRMES09'         => floatval (str_replace(",", ".",$row['VRMES09'])),
                        'P_VRMES10'         => floatval (str_replace(",", ".",$row['VRMES10'])),
                        'P_VRMES11'         => floatval (str_replace(",", ".",$row['VRMES11'])),
                        'P_VRMES12'         => floatval (str_replace(",", ".",$row['VRMES12'])),
                        'P_DTULTATU'        => $this->crudService->getEnvironment()->getCurrentTime()->format("d/m/Y H:i:s"),
                        'P_NRORGULTATU'     => $this->environment->getNrorg(),
                        'P_CDOPERULTATU'    => $this->environment->getCdOperador()
                    );
                    
                    $stmt = $this->connection->prepare("
                    UPDATE 
                        PERCCORRECAOGOP
                    SET
                        VRMES01      = :P_VRMES01,
                        VRMES02      = :P_VRMES02,
                        VRMES03      = :P_VRMES03,
                        VRMES04      = :P_VRMES04,
                        VRMES05      = :P_VRMES05,
                        VRMES06      = :P_VRMES06,
                        VRMES07      = :P_VRMES07,
                        VRMES08      = :P_VRMES08,
                        VRMES09      = :P_VRMES09,
                        VRMES10      = :P_VRMES10,
                        VRMES11      = :P_VRMES11,
                        VRMES12      = :P_VRMES12,
                        DTULTATU     = :P_DTULTATU,
                        NRORGULTATU  = :P_NRORGULTATU,
                        CDOPERULTATU = :P_CDOPERULTATU
                     WHERE
                        NRPERCCORRECAOGOP = :NRPERCCORRECAOGOP");
                        
                    try{
                        $stmt->execute($parametros);
                    }catch(\Exception $ex){
                        $response->setError(new Error("Nao foi possivel processar os dados enviados   --- " . $ex->getMessage(), 500));
                    }
                }
            } 
        }
    }
    
    public function updateFilialCadAuto(DTO\Request $request, DTO\Response $response ){
        
        $dados = $request->getDataSet();

        
        if(!empty($dados)){
            
            $rows = $dados->getRows();
                
            if(!empty($rows)){ 
                
                $rowPri = $rows[0];

                $tiposOrcamento = $rows[0]["IDTIPOORCAOP"];

                foreach($rows[0]["ANOS"] as   $ano ){
                    
                    foreach($rows[0]["NMFILIAL"] as $cdFilial){
                        
                        foreach( $tiposOrcamento as  $idtipoorcaop){
                            
                            
                            
                            $row["CDFILIAL"]     = $cdFilial;
                            $row["CDANO"]        = $ano;
                            $row["IDTIPOORCAOP"] = $idtipoorcaop;
                            
                            $conditions = array(
                                array(
                                    "columnName" => "CDFILIAL",
                                    "operator"   => '=',
                                    "value"      => $cdFilial
                                ),
                                array(
                                    "columnName" => "CDANO",
                                    "operator"   => '=',
                                    "value"      => $ano
                                ),
                                array(
                                    "columnName" => "IDTIPOORCAOP",
                                    "operator"   => "=",
                                    "value"      => $idtipoorcaop)
                            ); 
                            
                            
                            $dataSet = $this->crudService->getFilteredDataSet("perccorrecaogop", $conditions);
                           

                            if(count($dataSet->getRows()) == 0){
                                
                                $row["__is_new"] = true;
                                $row['NRPERCCORRECAOGOP'] = $this->newCode->getCodeByTableName("PERCCORRECAOGOP", $this->environment->getNrorg());
                                $row['DTINCLUSAO']        = $this->crudService->getEnvironment()->getCurrentTime()->format("d/m/Y H:i:s");
                                $row['CDOPERINCLUSAO']    = $this->environment->getCdOperador();
                                $row['NRORGINCLUSAO']     = $this->environment->getNrorg();
                                $row['DTULTATU']          = null;
                                $row['NRORGULTATU']       = null;
                                $row['CDOPERULTATU']      = null;
                                $row["IDATIVO"] = 'S';
                                
                                
                                if(!is_null($rowPri['VRMES01'])){
                                    $row['VRMES01'] = $rowPri['VRMES01'];
                                }else{
                                    $row['VRMES01'] = 0;
                                }
                                
                                if(!is_null($rowPri['VRMES02'])){
                                    $row['VRMES02'] = $rowPri['VRMES02'];
                                }else{
                                    $row['VRMES02'] = 0;
                                }
                                
                                if(!is_null($rowPri['VRMES03'])){
                                    $row['VRMES03'] = $rowPri['VRMES03'];
                                }else{
                                    $row['VRMES03'] = 0;
                                }
                                
                                if(!is_null($rowPri['VRMES04'])){
                                    $row['VRMES04'] = $rowPri['VRMES04'];
                                }else{
                                    $row['VRMES04'] = 0;
                                }
                                
                                if(!is_null($rowPri['VRMES05'])){
                                    $row['VRMES05'] = $rowPri['VRMES05'];
                                }else{
                                    $row['VRMES05'] = 0;
                                }
                                
                                if(!is_null($rowPri['VRMES06'])){
                                    $row['VRMES06'] = $rowPri['VRMES06'];
                                }else{
                                    $row['VRMES06'] = 0;
                                }
                                
                                if(!is_null($rowPri['VRMES07'])){
                                    $row['VRMES07'] = $rowPri['VRMES07'];
                                }else{
                                    $row['VRMES07'] = 0;
                                }
                                
                                if(!is_null($rowPri['VRMES08'])){
                                    $row['VRMES08'] = $rowPri['VRMES08'];
                                }else{
                                    $row['VRMES08'] = 0;
                                }
                                
                                if(!is_null($rowPri['VRMES09'])){
                                    $row['VRMES09'] = $rowPri['VRMES09'];
                                }else{
                                    $row['VRMES09'] = 0;
                                }
                                
                                if(!is_null($rowPri['VRMES10'])){
                                    $row['VRMES10'] = $rowPri['VRMES10'];
                                }else{
                                    $row['VRMES10'] = 0;
                                }
                                
                                if(!is_null($rowPri['VRMES11'])){
                                    $row['VRMES11'] = $rowPri['VRMES11'];
                                }else{
                                    $row['VRMES11'] = 0;
                                }
                                
                                if(!is_null($rowPri['VRMES12'])){
                                    $row['VRMES12'] = $rowPri['VRMES12'];
                                }else{
                                    $row['VRMES12'] = 0;
                                }
                                
                            }else {
                                
                                $row["__is_new"] = false;
                                $row['NRPERCCORRECAOGOP'] = $dataSet->getRows()[0]['NRPERCCORRECAOGOP'];
                                $row['DTINCLUSAO']        = $dataSet->getRows()[0]['DTINCLUSAO'];
                                $row['NRORGINCLUSAO']     = $dataSet->getRows()[0]['NRORGINCLUSAO'];
                                $row['CDOPERINCLUSAO']    = $dataSet->getRows()[0]['CDOPERINCLUSAO'];
                                $row["IDATIVO"]           = $dataSet->getRows()[0]['IDATIVO'];
                                $row['DTULTATU']          = $this->crudService->getEnvironment()->getCurrentTime()->format("d/m/Y H:i:s");
                                $row['NRORGULTATU']       = $this->environment->getNrorg();
                                $row['CDOPERULTATU']      = $this->environment->getCdOperador();
                                $row['IDTIPOORCAOP']      = $dataSet->getRows()[0]['IDTIPOORCAOP'];
                                

                            
                                if(!is_null($rowPri['VRMES01'])){
                                    $row['VRMES01'] = $rowPri['VRMES01'];
                                }else{
                                    $row['VRMES01'] = $dataSet->getRows()[0]['VRMES01'];
                                }
                                
                                if(!is_null($rowPri['VRMES02'])){
                                    $row['VRMES02'] = $rowPri['VRMES02'];
                                }else{
                                    $row['VRMES02'] = $dataSet->getRows()[0]['VRMES02'];
                                }
                                
                                if(!is_null($rowPri['VRMES03'])){
                                    $row['VRMES03'] = $rowPri['VRMES03'];
                                }else{
                                    $row['VRMES03'] = $dataSet->getRows()[0]['VRMES03'];
                                }
                                
                                if(!is_null($rowPri['VRMES04'])){
                                    $row['VRMES04'] = $rowPri['VRMES04'];
                                }else{
                                    $row['VRMES04'] = $dataSet->getRows()[0]['VRMES04'];
                                }

                                if(!is_null($rowPri['VRMES05'])){
                                    $row['VRMES05'] = $rowPri['VRMES05'];
                                }else{
                                    $row['VRMES05'] = $dataSet->getRows()[0]['VRMES05'];

                                }
                                if(!is_null($rowPri['VRMES06'])){
                                    $row['VRMES06'] = $rowPri['VRMES06'];
                                }else{
                                    $row['VRMES06'] = $dataSet->getRows()[0]['VRMES06'];
                                }
                                
                                if(!is_null($rowPri['VRMES07'])){
                                    $row['VRMES07'] = $rowPri['VRMES07'];
                                }else{
                                    $row['VRMES07'] = $dataSet->getRows()[0]['VRMES07'];
                                }
                                
                                if(!is_null($rowPri['VRMES08'])){
                                    $row['VRMES08'] = $rowPri['VRMES08'];
                                }else{
                                    $row['VRMES08'] = $dataSet->getRows()[0]['VRMES08'];
                                }
                                
                                if(!is_null($rowPri['VRMES09'])){
                                    $row['VRMES09'] = $rowPri['VRMES09'];
                                }else{
                                    $row['VRMES09'] = $dataSet->getRows()[0]['VRMES09'];
                                }
                                
                                if(!is_null($rowPri['VRMES10'])){
                                    $row['VRMES10'] = $rowPri['VRMES10'];
                                }else{
                                    $row['VRMES10'] = $dataSet->getRows()[0]['VRMES10'];
                                }
                                
                                if(!is_null($rowPri['VRMES11'])){
                                    $row['VRMES11'] = $rowPri['VRMES11'];
                                }else{
                                    $row['VRMES11'] = $dataSet->getRows()[0]['VRMES11'];
                                }
                                
                                if(!is_null($rowPri['VRMES12'])){
                                    $row['VRMES12'] = $rowPri['VRMES12'];
                                }else{
                                    $row['VRMES12'] = $dataSet->getRows()[0]['VRMES12'];
                                }
                            }
                            
                            $dataSetPp = new DataSet($this->dataSourceName, [$row]);
                            $request   = new DTO\Request\DataSet($dataSetPp, "", "", "");
                            $rowToSave = $this->crudService->getRowsToSave($request, "perccorrecaogop");
                            
                            try{ 
                                $this->crudService->save("perccorrecaogop", $rowToSave);
                            }catch(\Exception $ex){
                                $response->setError(new Error("Nao foi possivel processar os dados enviados   --- " . $ex->getMessage(), 500));
                            } 
                        }
                    }
                }
           }
        }
    }
    
    public function verificaFilial(DTO\Request $request, DTO\Response $response ){
        
        $cdfilial = $request->getDataSet()->getRows()[0][0];

        $parametros     = array(':P_CDFILIAL'  => $cdfilial);
        
        $stmt = $this->connection->prepare( 'SELECT IDCNTRRESC
                                                FROM FILIAL
                                            WHERE CDFILIAL = :P_CDFILIAL');
                                            
        $result = $stmt->execute($parametros);
        $result = $stmt->fetchAll();
        $response->addMessage(new Message($result));
    }
}