CREATE OR REPLACE TRIGGER USR_EXCLUSAO_EXPORTATITU
AFTER DELETE ON VENDA FOR EACH ROW
DECLARE
   V_DTGRV        DATE;
   V_HRGRV        VARCHAR2(04);

   V_NOVOCODIGO    INTEGER;
   V_FILIAL        VARCHAR2(02);
BEGIN
   V_DTGRV := NULL;
   V_HRGRV := NULL;

   /* Retorna data e hora de exportao */
   BEGIN
      SELECT TO_DATE(SYSDATE), TO_CHAR(SYSDATE,'HH24MI')
        INTO V_DTGRV, V_HRGRV
        FROM DUAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_DTGRV := NULL;
         V_HRGRV := NULL;
   END;

   SELECT MAX(CDGRUPFILI)
     INTO V_FILIAL
     FROM FILGRUPFILI
    WHERE CDFILIAL = :OLD.CDFILIAL
      AND USR_IDPROTHEUS = 'S';

   IF NOT V_FILIAL IS NULL THEN
      FOR C_USR_ZWC IN (
         SELECT CDFILIAL, CDCAIXA, NRSEQVENDA,
                WC_EMPRESA, WC_FILIAL , WC_PREFIXO,
                WC_NUM    , WC_IDTPREC,
                WC_CGC    , WC_EMISSAO,
                WC_VENCTO , WC_VENCREA,
                WC_VALOR  , WC_VLCRUZ
           FROM USR_ZWC
          WHERE CDFILIAL = :OLD.CDFILIAL
            AND CDCAIXA = :OLD.CDCAIXA
            AND NRSEQVENDA = :OLD.NRSEQVENDA) LOOP

         /* Retorna o sequencial para a tabela */
         BEGIN
            SELECT WC_IDTITRE.NEXTVAL
              INTO V_NOVOCODIGO
              FROM DUAL;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_NOVOCODIGO := 1;
         END;

         INSERT INTO USR_ZWC (
            CDFILIAL, CDCAIXA, NRSEQVENDA,
            WC_IDTITRE, WC_EMPRESA, WC_FILIAL , WC_PREFIXO,
            WC_NUM    , WC_IDTPREC,
            WC_CGC    , WC_EMISSAO,
            WC_VENCTO , WC_VENCREA,
            WC_VALOR  , WC_VLCRUZ , WC_TPEDI,
            WC_DTGRV  , WC_HRGRV  ,
            WC_DTIMP  , WC_HRIMP)
         VALUES
            (C_USR_ZWC.CDFILIAL, C_USR_ZWC.CDCAIXA, C_USR_ZWC.NRSEQVENDA,
             V_NOVOCODIGO, C_USR_ZWC.WC_EMPRESA, C_USR_ZWC.WC_FILIAL , C_USR_ZWC.WC_PREFIXO,
             C_USR_ZWC.WC_NUM    , C_USR_ZWC.WC_IDTPREC,
             C_USR_ZWC.WC_CGC    , C_USR_ZWC.WC_EMISSAO,
             C_USR_ZWC.WC_VENCTO , C_USR_ZWC.WC_VENCREA,
             C_USR_ZWC.WC_VALOR  , C_USR_ZWC.WC_VLCRUZ, '2',
             V_DTGRV, V_HRGRV,
             NULL, '');
      END LOOP;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_EXCLUSAO_EXPORTATITU','5.09.000'); END;
/
